#ifndef _VSCREEN_H_
#define _VSCREEN_H_

#include <termios.h>

#include <glib.h>

#ifdef _VIPER_WIDE
#include <ncursesw/curses.h>
#else
#include <curses.h>
#endif

#define	VSCREEN_SCROLLOK		(1<<1)
#define	VSCREEN_CWRAPPED		(1<<2)
#define	VSCREEN_CINVIS			(1<<3)
#define	VSCREEN_ACS				(1<<4)
#define	VSCREEN_CPARKED		(1<<5)

typedef struct _vscreen_s	vscreen_t;

struct _vscreen_s
{
	WINDOW			*window;
	void				(*activate)			(vscreen_t *);
	void				(*deactivate)		(vscreen_t *);
	void				(*write_char)		(vscreen_t *,chtype);
	void				(*move_cursor)		(vscreen_t *,int,int);
	struct termios	term_desc;
	guint				pty_fd;
	gint				fg,bg;
	guint				scr_id;
	guint				state;
};

#define VSCREEN(x)		((vscreen_t*)x)

void	vscreen_scrollok(vscreen_t *vscreen,gboolean toggle);
void	vscreen_show_cursor(vscreen_t *vscreen,gboolean toggle);
void	vscreen_move_cursor(vscreen_t *vscreen,gint y,gint x);
void	vscreen_addch(vscreen_t *vscreen,chtype ch);
void	vscreen_destroy(vscreen_t *vscreen);


#endif
